// Generated by gencpp from file gnss_info_msgs/SatellitePosition.msg
// DO NOT EDIT!


#ifndef GNSS_INFO_MSGS_MESSAGE_SATELLITEPOSITION_H
#define GNSS_INFO_MSGS_MESSAGE_SATELLITEPOSITION_H


#include <string>
#include <vector>
#include <memory>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <geometry_msgs/Point.h>
#include <geometry_msgs/Vector3.h>

namespace gnss_info_msgs
{
template <class ContainerAllocator>
struct SatellitePosition_
{
  typedef SatellitePosition_<ContainerAllocator> Type;

  SatellitePosition_()
    : satcat_id(0)
    , position()
    , velocity()
    , position_covariance()
    , velocity_covariance()  {
      position_covariance.assign(0.0);

      velocity_covariance.assign(0.0);
  }
  SatellitePosition_(const ContainerAllocator& _alloc)
    : satcat_id(0)
    , position(_alloc)
    , velocity(_alloc)
    , position_covariance()
    , velocity_covariance()  {
  (void)_alloc;
      position_covariance.assign(0.0);

      velocity_covariance.assign(0.0);
  }



   typedef uint32_t _satcat_id_type;
  _satcat_id_type satcat_id;

   typedef  ::geometry_msgs::Point_<ContainerAllocator>  _position_type;
  _position_type position;

   typedef  ::geometry_msgs::Vector3_<ContainerAllocator>  _velocity_type;
  _velocity_type velocity;

   typedef boost::array<double, 9>  _position_covariance_type;
  _position_covariance_type position_covariance;

   typedef boost::array<double, 9>  _velocity_covariance_type;
  _velocity_covariance_type velocity_covariance;





  typedef boost::shared_ptr< ::gnss_info_msgs::SatellitePosition_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::gnss_info_msgs::SatellitePosition_<ContainerAllocator> const> ConstPtr;

}; // struct SatellitePosition_

typedef ::gnss_info_msgs::SatellitePosition_<std::allocator<void> > SatellitePosition;

typedef boost::shared_ptr< ::gnss_info_msgs::SatellitePosition > SatellitePositionPtr;
typedef boost::shared_ptr< ::gnss_info_msgs::SatellitePosition const> SatellitePositionConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::gnss_info_msgs::SatellitePosition_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::gnss_info_msgs::SatellitePosition_<ContainerAllocator> >::stream(s, "", v);
return s;
}


template<typename ContainerAllocator1, typename ContainerAllocator2>
bool operator==(const ::gnss_info_msgs::SatellitePosition_<ContainerAllocator1> & lhs, const ::gnss_info_msgs::SatellitePosition_<ContainerAllocator2> & rhs)
{
  return lhs.satcat_id == rhs.satcat_id &&
    lhs.position == rhs.position &&
    lhs.velocity == rhs.velocity &&
    lhs.position_covariance == rhs.position_covariance &&
    lhs.velocity_covariance == rhs.velocity_covariance;
}

template<typename ContainerAllocator1, typename ContainerAllocator2>
bool operator!=(const ::gnss_info_msgs::SatellitePosition_<ContainerAllocator1> & lhs, const ::gnss_info_msgs::SatellitePosition_<ContainerAllocator2> & rhs)
{
  return !(lhs == rhs);
}


} // namespace gnss_info_msgs

namespace ros
{
namespace message_traits
{





template <class ContainerAllocator>
struct IsMessage< ::gnss_info_msgs::SatellitePosition_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::gnss_info_msgs::SatellitePosition_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::gnss_info_msgs::SatellitePosition_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::gnss_info_msgs::SatellitePosition_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::gnss_info_msgs::SatellitePosition_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::gnss_info_msgs::SatellitePosition_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::gnss_info_msgs::SatellitePosition_<ContainerAllocator> >
{
  static const char* value()
  {
    return "5f5e655c8f229deb5b452ab6fa9879e3";
  }

  static const char* value(const ::gnss_info_msgs::SatellitePosition_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x5f5e655c8f229debULL;
  static const uint64_t static_value2 = 0x5b452ab6fa9879e3ULL;
};

template<class ContainerAllocator>
struct DataType< ::gnss_info_msgs::SatellitePosition_<ContainerAllocator> >
{
  static const char* value()
  {
    return "gnss_info_msgs/SatellitePosition";
  }

  static const char* value(const ::gnss_info_msgs::SatellitePosition_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::gnss_info_msgs::SatellitePosition_<ContainerAllocator> >
{
  static const char* value()
  {
    return "# SPDX-License-Identifier: BSD-3-Clause\n"
"# SPDX-FileCopyrightText: Czech Technical University in Prague\n"
"\n"
"# ECEF position and velocity of a satellite.\n"
"\n"
"uint32 satcat_id  # SATCAT number (NORAD ID) of the satellite.\n"
"geometry_msgs/Point position  # Position of the satellite in ECEF frame.\n"
"geometry_msgs/Vector3 velocity  # Velocity of the satellite in ECEF frame.\n"
"float64[9] position_covariance  # Row-major covariance matrix of position. If all zeros, it is not specified.\n"
"float64[9] velocity_covariance  # Row-major covariance matrix of velocity. If all zeros, it is not specified.\n"
"================================================================================\n"
"MSG: geometry_msgs/Point\n"
"# This contains the position of a point in free space\n"
"float64 x\n"
"float64 y\n"
"float64 z\n"
"\n"
"================================================================================\n"
"MSG: geometry_msgs/Vector3\n"
"# This represents a vector in free space. \n"
"# It is only meant to represent a direction. Therefore, it does not\n"
"# make sense to apply a translation to it (e.g., when applying a \n"
"# generic rigid transformation to a Vector3, tf2 will only apply the\n"
"# rotation). If you want your data to be translatable too, use the\n"
"# geometry_msgs/Point message instead.\n"
"\n"
"float64 x\n"
"float64 y\n"
"float64 z\n"
;
  }

  static const char* value(const ::gnss_info_msgs::SatellitePosition_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::gnss_info_msgs::SatellitePosition_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.satcat_id);
      stream.next(m.position);
      stream.next(m.velocity);
      stream.next(m.position_covariance);
      stream.next(m.velocity_covariance);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER
  }; // struct SatellitePosition_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::gnss_info_msgs::SatellitePosition_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::gnss_info_msgs::SatellitePosition_<ContainerAllocator>& v)
  {
    s << indent << "satcat_id: ";
    Printer<uint32_t>::stream(s, indent + "  ", v.satcat_id);
    s << indent << "position: ";
    s << std::endl;
    Printer< ::geometry_msgs::Point_<ContainerAllocator> >::stream(s, indent + "  ", v.position);
    s << indent << "velocity: ";
    s << std::endl;
    Printer< ::geometry_msgs::Vector3_<ContainerAllocator> >::stream(s, indent + "  ", v.velocity);
    s << indent << "position_covariance[]" << std::endl;
    for (size_t i = 0; i < v.position_covariance.size(); ++i)
    {
      s << indent << "  position_covariance[" << i << "]: ";
      Printer<double>::stream(s, indent + "  ", v.position_covariance[i]);
    }
    s << indent << "velocity_covariance[]" << std::endl;
    for (size_t i = 0; i < v.velocity_covariance.size(); ++i)
    {
      s << indent << "  velocity_covariance[" << i << "]: ";
      Printer<double>::stream(s, indent + "  ", v.velocity_covariance[i]);
    }
  }
};

} // namespace message_operations
} // namespace ros

#endif // GNSS_INFO_MSGS_MESSAGE_SATELLITEPOSITION_H
