# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from gnss_info_msgs/SatelliteObservation.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geometry_msgs.msg
import gnss_info_msgs.msg

class SatelliteObservation(genpy.Message):
  _md5sum = "e5166f13ee4cd50ed431ed5a5b2ed396"
  _type = "gnss_info_msgs/SatelliteObservation"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# SPDX-License-Identifier: BSD-3-Clause
# SPDX-FileCopyrightText: Czech Technical University in Prague

# Observation of a single satellite in the sky by a particular sensor. This message is intended to be used only inside
# SatellitesObservation message.

SatellitePosition position
SignalObservation[] signals
================================================================================
MSG: gnss_info_msgs/SatellitePosition
# SPDX-License-Identifier: BSD-3-Clause
# SPDX-FileCopyrightText: Czech Technical University in Prague

# ECEF position and velocity of a satellite.

uint32 satcat_id  # SATCAT number (NORAD ID) of the satellite.
geometry_msgs/Point position  # Position of the satellite in ECEF frame.
geometry_msgs/Vector3 velocity  # Velocity of the satellite in ECEF frame.
float64[9] position_covariance  # Row-major covariance matrix of position. If all zeros, it is not specified.
float64[9] velocity_covariance  # Row-major covariance matrix of velocity. If all zeros, it is not specified.
================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 
# It is only meant to represent a direction. Therefore, it does not
# make sense to apply a translation to it (e.g., when applying a 
# generic rigid transformation to a Vector3, tf2 will only apply the
# rotation). If you want your data to be translatable too, use the
# geometry_msgs/Point message instead.

float64 x
float64 y
float64 z
================================================================================
MSG: gnss_info_msgs/SignalObservation
# SPDX-License-Identifier: BSD-3-Clause
# SPDX-FileCopyrightText: Czech Technical University in Prague

# Observation of a single satellite in the sky by a particular sensor. This message is intended to be used only inside
# SatellitesObservation message.

SatelliteSignal signal
float64 pseudorange  # The measured pseudorange (NaN if not measured; in meters).
float64 carrier_phase  # The estimated carrier phase (NaN if not measured; float number of cycles).
float64 doppler_shift  # Difference between observed and emitted frequency of the carrier (NaN if not measured; in Hz).
float64 carrier_to_noise_ratio  #  Strength of the received signal (NaN if not measured; in dbHz).
bool carrier_locked  # False if carrier lock has been lost since the last measurement (thus a cycle slip is possible).
================================================================================
MSG: gnss_info_msgs/SatelliteSignal
# SPDX-License-Identifier: BSD-3-Clause
# SPDX-FileCopyrightText: Czech Technical University in Prague

# General information about a particular satellite signal.

string name  # Name of the signal. One of SIGNAL_* values from Enums.msg
string constellation  # Constellation the signal is a part of. One of CONSTELLATION_* values from Enums.msg
float32 frequency  # Center frequency band of the signal in Hz (0 if not known). For GLONASS, the channel-based
                   # frequency shift should be applied."""
  __slots__ = ['position','signals']
  _slot_types = ['gnss_info_msgs/SatellitePosition','gnss_info_msgs/SignalObservation[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       position,signals

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(SatelliteObservation, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.position is None:
        self.position = gnss_info_msgs.msg.SatellitePosition()
      if self.signals is None:
        self.signals = []
    else:
      self.position = gnss_info_msgs.msg.SatellitePosition()
      self.signals = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_I6d().pack(_x.position.satcat_id, _x.position.position.x, _x.position.position.y, _x.position.position.z, _x.position.velocity.x, _x.position.velocity.y, _x.position.velocity.z))
      buff.write(_get_struct_9d().pack(*self.position.position_covariance))
      buff.write(_get_struct_9d().pack(*self.position.velocity_covariance))
      length = len(self.signals)
      buff.write(_struct_I.pack(length))
      for val1 in self.signals:
        _v1 = val1.signal
        _x = _v1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v1.constellation
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v1.frequency
        buff.write(_get_struct_f().pack(_x))
        _x = val1
        buff.write(_get_struct_4dB().pack(_x.pseudorange, _x.carrier_phase, _x.doppler_shift, _x.carrier_to_noise_ratio, _x.carrier_locked))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.position is None:
        self.position = gnss_info_msgs.msg.SatellitePosition()
      if self.signals is None:
        self.signals = None
      end = 0
      _x = self
      start = end
      end += 52
      (_x.position.satcat_id, _x.position.position.x, _x.position.position.y, _x.position.position.z, _x.position.velocity.x, _x.position.velocity.y, _x.position.velocity.z,) = _get_struct_I6d().unpack(str[start:end])
      start = end
      end += 72
      self.position.position_covariance = _get_struct_9d().unpack(str[start:end])
      start = end
      end += 72
      self.position.velocity_covariance = _get_struct_9d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.signals = []
      for i in range(0, length):
        val1 = gnss_info_msgs.msg.SignalObservation()
        _v2 = val1.signal
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v2.name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v2.name = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v2.constellation = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v2.constellation = str[start:end]
        start = end
        end += 4
        (_v2.frequency,) = _get_struct_f().unpack(str[start:end])
        _x = val1
        start = end
        end += 33
        (_x.pseudorange, _x.carrier_phase, _x.doppler_shift, _x.carrier_to_noise_ratio, _x.carrier_locked,) = _get_struct_4dB().unpack(str[start:end])
        val1.carrier_locked = bool(val1.carrier_locked)
        self.signals.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_I6d().pack(_x.position.satcat_id, _x.position.position.x, _x.position.position.y, _x.position.position.z, _x.position.velocity.x, _x.position.velocity.y, _x.position.velocity.z))
      buff.write(self.position.position_covariance.tostring())
      buff.write(self.position.velocity_covariance.tostring())
      length = len(self.signals)
      buff.write(_struct_I.pack(length))
      for val1 in self.signals:
        _v3 = val1.signal
        _x = _v3.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v3.constellation
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v3.frequency
        buff.write(_get_struct_f().pack(_x))
        _x = val1
        buff.write(_get_struct_4dB().pack(_x.pseudorange, _x.carrier_phase, _x.doppler_shift, _x.carrier_to_noise_ratio, _x.carrier_locked))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.position is None:
        self.position = gnss_info_msgs.msg.SatellitePosition()
      if self.signals is None:
        self.signals = None
      end = 0
      _x = self
      start = end
      end += 52
      (_x.position.satcat_id, _x.position.position.x, _x.position.position.y, _x.position.position.z, _x.position.velocity.x, _x.position.velocity.y, _x.position.velocity.z,) = _get_struct_I6d().unpack(str[start:end])
      start = end
      end += 72
      self.position.position_covariance = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=9)
      start = end
      end += 72
      self.position.velocity_covariance = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=9)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.signals = []
      for i in range(0, length):
        val1 = gnss_info_msgs.msg.SignalObservation()
        _v4 = val1.signal
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v4.name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v4.name = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v4.constellation = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v4.constellation = str[start:end]
        start = end
        end += 4
        (_v4.frequency,) = _get_struct_f().unpack(str[start:end])
        _x = val1
        start = end
        end += 33
        (_x.pseudorange, _x.carrier_phase, _x.doppler_shift, _x.carrier_to_noise_ratio, _x.carrier_locked,) = _get_struct_4dB().unpack(str[start:end])
        val1.carrier_locked = bool(val1.carrier_locked)
        self.signals.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_4dB = None
def _get_struct_4dB():
    global _struct_4dB
    if _struct_4dB is None:
        _struct_4dB = struct.Struct("<4dB")
    return _struct_4dB
_struct_9d = None
def _get_struct_9d():
    global _struct_9d
    if _struct_9d is None:
        _struct_9d = struct.Struct("<9d")
    return _struct_9d
_struct_I6d = None
def _get_struct_I6d():
    global _struct_I6d
    if _struct_I6d is None:
        _struct_I6d = struct.Struct("<I6d")
    return _struct_I6d
_struct_f = None
def _get_struct_f():
    global _struct_f
    if _struct_f is None:
        _struct_f = struct.Struct("<f")
    return _struct_f
