# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from gnss_info_msgs/SatelliteSkyPosition.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class SatelliteSkyPosition(genpy.Message):
  _md5sum = "a5a93b6ae2c1ee19d32ebb4c3563c1c8"
  _type = "gnss_info_msgs/SatelliteSkyPosition"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# SPDX-License-Identifier: BSD-3-Clause
# SPDX-FileCopyrightText: Czech Technical University in Prague

# Position of a satellite in the sky as seen from a particular reference position.

uint32 satcat_id  # SATCAT number (NORAD ID) of the satellite.
float32 azimuth_deg  # Azimuth in the sky (in degress, NED convention).
float32 elevation_deg  # Elevation in the sky (in degress, positive values above local horizon).
float64 distance  # Distance of the satellite to the reference position (corrected for Sagnac effect; in meters)."""
  __slots__ = ['satcat_id','azimuth_deg','elevation_deg','distance']
  _slot_types = ['uint32','float32','float32','float64']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       satcat_id,azimuth_deg,elevation_deg,distance

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(SatelliteSkyPosition, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.satcat_id is None:
        self.satcat_id = 0
      if self.azimuth_deg is None:
        self.azimuth_deg = 0.
      if self.elevation_deg is None:
        self.elevation_deg = 0.
      if self.distance is None:
        self.distance = 0.
    else:
      self.satcat_id = 0
      self.azimuth_deg = 0.
      self.elevation_deg = 0.
      self.distance = 0.

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_I2fd().pack(_x.satcat_id, _x.azimuth_deg, _x.elevation_deg, _x.distance))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 20
      (_x.satcat_id, _x.azimuth_deg, _x.elevation_deg, _x.distance,) = _get_struct_I2fd().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_I2fd().pack(_x.satcat_id, _x.azimuth_deg, _x.elevation_deg, _x.distance))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 20
      (_x.satcat_id, _x.azimuth_deg, _x.elevation_deg, _x.distance,) = _get_struct_I2fd().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_I2fd = None
def _get_struct_I2fd():
    global _struct_I2fd
    if _struct_I2fd is None:
        _struct_I2fd = struct.Struct("<I2fd")
    return _struct_I2fd
