# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from gnss_info_msgs/SatellitesList.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import genpy
import gnss_info_msgs.msg

class SatellitesList(genpy.Message):
  _md5sum = "839c1013b162d3068ee7b42fda814e1f"
  _type = "gnss_info_msgs/SatellitesList"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# SPDX-License-Identifier: BSD-3-Clause
# SPDX-FileCopyrightText: Czech Technical University in Prague

# General information about several satellites.

SatelliteInfo[] satellites  # The satellites.
================================================================================
MSG: gnss_info_msgs/SatelliteInfo
# SPDX-License-Identifier: BSD-3-Clause
# SPDX-FileCopyrightText: Czech Technical University in Prague

# General information about a satellite.

time stamp  # The time to which this data are valid. Some values like prn or active state may change over time.
uint32 satcat_id  # SATCAT number (NORAD ID) of the satellite. This ID should be used as a stable identifier.
string name  # Name of the satellite. It should not be used as a stable identifier.
string prn  # PRN of the satellite at the given time. If the satellite is not active at the given time, empty string.
            # Either 2-3 digits, or 1 letter and 2 digits.
string constellation  # One of CONSTELLATION_* values from Enums.msg
bool active  # True if the satellite is in operational state, False otherwise (decommissioned, faulty, experimental).
SatelliteSignal[] signals  # The signal types transmitted by the satellite at the given time.
================================================================================
MSG: gnss_info_msgs/SatelliteSignal
# SPDX-License-Identifier: BSD-3-Clause
# SPDX-FileCopyrightText: Czech Technical University in Prague

# General information about a particular satellite signal.

string name  # Name of the signal. One of SIGNAL_* values from Enums.msg
string constellation  # Constellation the signal is a part of. One of CONSTELLATION_* values from Enums.msg
float32 frequency  # Center frequency band of the signal in Hz (0 if not known). For GLONASS, the channel-based
                   # frequency shift should be applied."""
  __slots__ = ['satellites']
  _slot_types = ['gnss_info_msgs/SatelliteInfo[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       satellites

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(SatellitesList, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.satellites is None:
        self.satellites = []
    else:
      self.satellites = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      length = len(self.satellites)
      buff.write(_struct_I.pack(length))
      for val1 in self.satellites:
        _v1 = val1.stamp
        _x = _v1
        buff.write(_get_struct_2I().pack(_x.secs, _x.nsecs))
        _x = val1.satcat_id
        buff.write(_get_struct_I().pack(_x))
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.prn
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.constellation
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.active
        buff.write(_get_struct_B().pack(_x))
        length = len(val1.signals)
        buff.write(_struct_I.pack(length))
        for val2 in val1.signals:
          _x = val2.name
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _x = val2.constellation
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _x = val2.frequency
          buff.write(_get_struct_f().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.satellites is None:
        self.satellites = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.satellites = []
      for i in range(0, length):
        val1 = gnss_info_msgs.msg.SatelliteInfo()
        _v2 = val1.stamp
        _x = _v2
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2I().unpack(str[start:end])
        start = end
        end += 4
        (val1.satcat_id,) = _get_struct_I().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.name = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.prn = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.prn = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.constellation = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.constellation = str[start:end]
        start = end
        end += 1
        (val1.active,) = _get_struct_B().unpack(str[start:end])
        val1.active = bool(val1.active)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.signals = []
        for i in range(0, length):
          val2 = gnss_info_msgs.msg.SatelliteSignal()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.name = str[start:end].decode('utf-8', 'rosmsg')
          else:
            val2.name = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.constellation = str[start:end].decode('utf-8', 'rosmsg')
          else:
            val2.constellation = str[start:end]
          start = end
          end += 4
          (val2.frequency,) = _get_struct_f().unpack(str[start:end])
          val1.signals.append(val2)
        self.satellites.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      length = len(self.satellites)
      buff.write(_struct_I.pack(length))
      for val1 in self.satellites:
        _v3 = val1.stamp
        _x = _v3
        buff.write(_get_struct_2I().pack(_x.secs, _x.nsecs))
        _x = val1.satcat_id
        buff.write(_get_struct_I().pack(_x))
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.prn
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.constellation
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.active
        buff.write(_get_struct_B().pack(_x))
        length = len(val1.signals)
        buff.write(_struct_I.pack(length))
        for val2 in val1.signals:
          _x = val2.name
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _x = val2.constellation
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _x = val2.frequency
          buff.write(_get_struct_f().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.satellites is None:
        self.satellites = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.satellites = []
      for i in range(0, length):
        val1 = gnss_info_msgs.msg.SatelliteInfo()
        _v4 = val1.stamp
        _x = _v4
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2I().unpack(str[start:end])
        start = end
        end += 4
        (val1.satcat_id,) = _get_struct_I().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.name = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.prn = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.prn = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.constellation = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.constellation = str[start:end]
        start = end
        end += 1
        (val1.active,) = _get_struct_B().unpack(str[start:end])
        val1.active = bool(val1.active)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.signals = []
        for i in range(0, length):
          val2 = gnss_info_msgs.msg.SatelliteSignal()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.name = str[start:end].decode('utf-8', 'rosmsg')
          else:
            val2.name = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.constellation = str[start:end].decode('utf-8', 'rosmsg')
          else:
            val2.constellation = str[start:end]
          start = end
          end += 4
          (val2.frequency,) = _get_struct_f().unpack(str[start:end])
          val1.signals.append(val2)
        self.satellites.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2I = None
def _get_struct_2I():
    global _struct_2I
    if _struct_2I is None:
        _struct_2I = struct.Struct("<2I")
    return _struct_2I
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
_struct_f = None
def _get_struct_f():
    global _struct_f
    if _struct_f is None:
        _struct_f = struct.Struct("<f")
    return _struct_f
