# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from gnss_info_msgs/SatellitesObservations.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geometry_msgs.msg
import gnss_info_msgs.msg
import std_msgs.msg

class SatellitesObservations(genpy.Message):
  _md5sum = "e295439f84d7f1f02052eff4806eeba9"
  _type = "gnss_info_msgs/SatellitesObservations"
  _has_header = True  # flag to mark the presence of a Header object
  _full_text = """# SPDX-License-Identifier: BSD-3-Clause
# SPDX-FileCopyrightText: Czech Technical University in Prague

# Observation of satellites in the sky by a particular sensor.

Header header  # Frame should be "wgs84" or any other datum in which the reference position is expressed.
               # Stamp is receiver time.
float32 elevation_mask_deg  # Minimum elevation of satellites that are considered (in degrees).
SatelliteObservation[] observations
================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
string frame_id

================================================================================
MSG: gnss_info_msgs/SatelliteObservation
# SPDX-License-Identifier: BSD-3-Clause
# SPDX-FileCopyrightText: Czech Technical University in Prague

# Observation of a single satellite in the sky by a particular sensor. This message is intended to be used only inside
# SatellitesObservation message.

SatellitePosition position
SignalObservation[] signals
================================================================================
MSG: gnss_info_msgs/SatellitePosition
# SPDX-License-Identifier: BSD-3-Clause
# SPDX-FileCopyrightText: Czech Technical University in Prague

# ECEF position and velocity of a satellite.

uint32 satcat_id  # SATCAT number (NORAD ID) of the satellite.
geometry_msgs/Point position  # Position of the satellite in ECEF frame.
geometry_msgs/Vector3 velocity  # Velocity of the satellite in ECEF frame.
float64[9] position_covariance  # Row-major covariance matrix of position. If all zeros, it is not specified.
float64[9] velocity_covariance  # Row-major covariance matrix of velocity. If all zeros, it is not specified.
================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 
# It is only meant to represent a direction. Therefore, it does not
# make sense to apply a translation to it (e.g., when applying a 
# generic rigid transformation to a Vector3, tf2 will only apply the
# rotation). If you want your data to be translatable too, use the
# geometry_msgs/Point message instead.

float64 x
float64 y
float64 z
================================================================================
MSG: gnss_info_msgs/SignalObservation
# SPDX-License-Identifier: BSD-3-Clause
# SPDX-FileCopyrightText: Czech Technical University in Prague

# Observation of a single satellite in the sky by a particular sensor. This message is intended to be used only inside
# SatellitesObservation message.

SatelliteSignal signal
float64 pseudorange  # The measured pseudorange (NaN if not measured; in meters).
float64 carrier_phase  # The estimated carrier phase (NaN if not measured; float number of cycles).
float64 doppler_shift  # Difference between observed and emitted frequency of the carrier (NaN if not measured; in Hz).
float64 carrier_to_noise_ratio  #  Strength of the received signal (NaN if not measured; in dbHz).
bool carrier_locked  # False if carrier lock has been lost since the last measurement (thus a cycle slip is possible).
================================================================================
MSG: gnss_info_msgs/SatelliteSignal
# SPDX-License-Identifier: BSD-3-Clause
# SPDX-FileCopyrightText: Czech Technical University in Prague

# General information about a particular satellite signal.

string name  # Name of the signal. One of SIGNAL_* values from Enums.msg
string constellation  # Constellation the signal is a part of. One of CONSTELLATION_* values from Enums.msg
float32 frequency  # Center frequency band of the signal in Hz (0 if not known). For GLONASS, the channel-based
                   # frequency shift should be applied."""
  __slots__ = ['header','elevation_mask_deg','observations']
  _slot_types = ['std_msgs/Header','float32','gnss_info_msgs/SatelliteObservation[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,elevation_mask_deg,observations

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(SatellitesObservations, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.elevation_mask_deg is None:
        self.elevation_mask_deg = 0.
      if self.observations is None:
        self.observations = []
    else:
      self.header = std_msgs.msg.Header()
      self.elevation_mask_deg = 0.
      self.observations = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.elevation_mask_deg
      buff.write(_get_struct_f().pack(_x))
      length = len(self.observations)
      buff.write(_struct_I.pack(length))
      for val1 in self.observations:
        _v1 = val1.position
        _x = _v1.satcat_id
        buff.write(_get_struct_I().pack(_x))
        _v2 = _v1.position
        _x = _v2
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v3 = _v1.velocity
        _x = _v3
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        buff.write(_get_struct_9d().pack(*_v1.position_covariance))
        buff.write(_get_struct_9d().pack(*_v1.velocity_covariance))
        length = len(val1.signals)
        buff.write(_struct_I.pack(length))
        for val2 in val1.signals:
          _v4 = val2.signal
          _x = _v4.name
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _x = _v4.constellation
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _x = _v4.frequency
          buff.write(_get_struct_f().pack(_x))
          _x = val2
          buff.write(_get_struct_4dB().pack(_x.pseudorange, _x.carrier_phase, _x.doppler_shift, _x.carrier_to_noise_ratio, _x.carrier_locked))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.observations is None:
        self.observations = None
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      start = end
      end += 4
      (self.elevation_mask_deg,) = _get_struct_f().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.observations = []
      for i in range(0, length):
        val1 = gnss_info_msgs.msg.SatelliteObservation()
        _v5 = val1.position
        start = end
        end += 4
        (_v5.satcat_id,) = _get_struct_I().unpack(str[start:end])
        _v6 = _v5.position
        _x = _v6
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v7 = _v5.velocity
        _x = _v7
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        start = end
        end += 72
        _v5.position_covariance = _get_struct_9d().unpack(str[start:end])
        start = end
        end += 72
        _v5.velocity_covariance = _get_struct_9d().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.signals = []
        for i in range(0, length):
          val2 = gnss_info_msgs.msg.SignalObservation()
          _v8 = val2.signal
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v8.name = str[start:end].decode('utf-8', 'rosmsg')
          else:
            _v8.name = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v8.constellation = str[start:end].decode('utf-8', 'rosmsg')
          else:
            _v8.constellation = str[start:end]
          start = end
          end += 4
          (_v8.frequency,) = _get_struct_f().unpack(str[start:end])
          _x = val2
          start = end
          end += 33
          (_x.pseudorange, _x.carrier_phase, _x.doppler_shift, _x.carrier_to_noise_ratio, _x.carrier_locked,) = _get_struct_4dB().unpack(str[start:end])
          val2.carrier_locked = bool(val2.carrier_locked)
          val1.signals.append(val2)
        self.observations.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.elevation_mask_deg
      buff.write(_get_struct_f().pack(_x))
      length = len(self.observations)
      buff.write(_struct_I.pack(length))
      for val1 in self.observations:
        _v9 = val1.position
        _x = _v9.satcat_id
        buff.write(_get_struct_I().pack(_x))
        _v10 = _v9.position
        _x = _v10
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v11 = _v9.velocity
        _x = _v11
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        buff.write(_v9.position_covariance.tostring())
        buff.write(_v9.velocity_covariance.tostring())
        length = len(val1.signals)
        buff.write(_struct_I.pack(length))
        for val2 in val1.signals:
          _v12 = val2.signal
          _x = _v12.name
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _x = _v12.constellation
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _x = _v12.frequency
          buff.write(_get_struct_f().pack(_x))
          _x = val2
          buff.write(_get_struct_4dB().pack(_x.pseudorange, _x.carrier_phase, _x.doppler_shift, _x.carrier_to_noise_ratio, _x.carrier_locked))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.observations is None:
        self.observations = None
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      start = end
      end += 4
      (self.elevation_mask_deg,) = _get_struct_f().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.observations = []
      for i in range(0, length):
        val1 = gnss_info_msgs.msg.SatelliteObservation()
        _v13 = val1.position
        start = end
        end += 4
        (_v13.satcat_id,) = _get_struct_I().unpack(str[start:end])
        _v14 = _v13.position
        _x = _v14
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v15 = _v13.velocity
        _x = _v15
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        start = end
        end += 72
        _v13.position_covariance = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=9)
        start = end
        end += 72
        _v13.velocity_covariance = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=9)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.signals = []
        for i in range(0, length):
          val2 = gnss_info_msgs.msg.SignalObservation()
          _v16 = val2.signal
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v16.name = str[start:end].decode('utf-8', 'rosmsg')
          else:
            _v16.name = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v16.constellation = str[start:end].decode('utf-8', 'rosmsg')
          else:
            _v16.constellation = str[start:end]
          start = end
          end += 4
          (_v16.frequency,) = _get_struct_f().unpack(str[start:end])
          _x = val2
          start = end
          end += 33
          (_x.pseudorange, _x.carrier_phase, _x.doppler_shift, _x.carrier_to_noise_ratio, _x.carrier_locked,) = _get_struct_4dB().unpack(str[start:end])
          val2.carrier_locked = bool(val2.carrier_locked)
          val1.signals.append(val2)
        self.observations.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
_struct_3d = None
def _get_struct_3d():
    global _struct_3d
    if _struct_3d is None:
        _struct_3d = struct.Struct("<3d")
    return _struct_3d
_struct_4dB = None
def _get_struct_4dB():
    global _struct_4dB
    if _struct_4dB is None:
        _struct_4dB = struct.Struct("<4dB")
    return _struct_4dB
_struct_9d = None
def _get_struct_9d():
    global _struct_9d
    if _struct_9d is None:
        _struct_9d = struct.Struct("<9d")
    return _struct_9d
_struct_f = None
def _get_struct_f():
    global _struct_f
    if _struct_f is None:
        _struct_f = struct.Struct("<f")
    return _struct_f
