# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from gnss_info_msgs/SignalObservation.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import gnss_info_msgs.msg

class SignalObservation(genpy.Message):
  _md5sum = "673e2ca27df1e4872336572196854331"
  _type = "gnss_info_msgs/SignalObservation"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# SPDX-License-Identifier: BSD-3-Clause
# SPDX-FileCopyrightText: Czech Technical University in Prague

# Observation of a single satellite in the sky by a particular sensor. This message is intended to be used only inside
# SatellitesObservation message.

SatelliteSignal signal
float64 pseudorange  # The measured pseudorange (NaN if not measured; in meters).
float64 carrier_phase  # The estimated carrier phase (NaN if not measured; float number of cycles).
float64 doppler_shift  # Difference between observed and emitted frequency of the carrier (NaN if not measured; in Hz).
float64 carrier_to_noise_ratio  #  Strength of the received signal (NaN if not measured; in dbHz).
bool carrier_locked  # False if carrier lock has been lost since the last measurement (thus a cycle slip is possible).
================================================================================
MSG: gnss_info_msgs/SatelliteSignal
# SPDX-License-Identifier: BSD-3-Clause
# SPDX-FileCopyrightText: Czech Technical University in Prague

# General information about a particular satellite signal.

string name  # Name of the signal. One of SIGNAL_* values from Enums.msg
string constellation  # Constellation the signal is a part of. One of CONSTELLATION_* values from Enums.msg
float32 frequency  # Center frequency band of the signal in Hz (0 if not known). For GLONASS, the channel-based
                   # frequency shift should be applied."""
  __slots__ = ['signal','pseudorange','carrier_phase','doppler_shift','carrier_to_noise_ratio','carrier_locked']
  _slot_types = ['gnss_info_msgs/SatelliteSignal','float64','float64','float64','float64','bool']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       signal,pseudorange,carrier_phase,doppler_shift,carrier_to_noise_ratio,carrier_locked

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(SignalObservation, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.signal is None:
        self.signal = gnss_info_msgs.msg.SatelliteSignal()
      if self.pseudorange is None:
        self.pseudorange = 0.
      if self.carrier_phase is None:
        self.carrier_phase = 0.
      if self.doppler_shift is None:
        self.doppler_shift = 0.
      if self.carrier_to_noise_ratio is None:
        self.carrier_to_noise_ratio = 0.
      if self.carrier_locked is None:
        self.carrier_locked = False
    else:
      self.signal = gnss_info_msgs.msg.SatelliteSignal()
      self.pseudorange = 0.
      self.carrier_phase = 0.
      self.doppler_shift = 0.
      self.carrier_to_noise_ratio = 0.
      self.carrier_locked = False

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.signal.name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.signal.constellation
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_f4dB().pack(_x.signal.frequency, _x.pseudorange, _x.carrier_phase, _x.doppler_shift, _x.carrier_to_noise_ratio, _x.carrier_locked))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.signal is None:
        self.signal = gnss_info_msgs.msg.SatelliteSignal()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.signal.name = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.signal.name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.signal.constellation = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.signal.constellation = str[start:end]
      _x = self
      start = end
      end += 37
      (_x.signal.frequency, _x.pseudorange, _x.carrier_phase, _x.doppler_shift, _x.carrier_to_noise_ratio, _x.carrier_locked,) = _get_struct_f4dB().unpack(str[start:end])
      self.carrier_locked = bool(self.carrier_locked)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.signal.name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.signal.constellation
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_f4dB().pack(_x.signal.frequency, _x.pseudorange, _x.carrier_phase, _x.doppler_shift, _x.carrier_to_noise_ratio, _x.carrier_locked))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.signal is None:
        self.signal = gnss_info_msgs.msg.SatelliteSignal()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.signal.name = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.signal.name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.signal.constellation = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.signal.constellation = str[start:end]
      _x = self
      start = end
      end += 37
      (_x.signal.frequency, _x.pseudorange, _x.carrier_phase, _x.doppler_shift, _x.carrier_to_noise_ratio, _x.carrier_locked,) = _get_struct_f4dB().unpack(str[start:end])
      self.carrier_locked = bool(self.carrier_locked)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_f4dB = None
def _get_struct_f4dB():
    global _struct_f4dB
    if _struct_f4dB is None:
        _struct_f4dB = struct.Struct("<f4dB")
    return _struct_f4dB
