# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from gnss_info_msgs/SkyView.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geographic_msgs.msg
import gnss_info_msgs.msg
import std_msgs.msg

class SkyView(genpy.Message):
  _md5sum = "db0126e8f4334f9bf177545ff9630a5b"
  _type = "gnss_info_msgs/SkyView"
  _has_header = True  # flag to mark the presence of a Header object
  _full_text = """# SPDX-License-Identifier: BSD-3-Clause
# SPDX-FileCopyrightText: Czech Technical University in Prague

# View of the satellites in the sky from a particular location on Earth. It can be either all available satellites,
# or only satellites visible by a particular sensor.

Header header  # Frame should be "wgs84" or any other datum in which the reference position is expressed.
geographic_msgs/GeoPoint reference_position  # The reference position from which the sky is observed.
float32 elevation_mask_deg  # Minimum elevation of satellites that are considered (in degrees).
SatelliteSkyPosition[] satellites
DOP dop
================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
string frame_id

================================================================================
MSG: geographic_msgs/GeoPoint
# Geographic point, using the WGS 84 reference ellipsoid.

# Latitude [degrees]. Positive is north of equator; negative is south
# (-90 <= latitude <= +90).
float64 latitude

# Longitude [degrees]. Positive is east of prime meridian; negative is
# west (-180 <= longitude <= +180). At the poles, latitude is -90 or
# +90, and longitude is irrelevant, but must be in range.
float64 longitude

# Altitude [m]. Positive is above the WGS 84 ellipsoid (NaN if unspecified).
float64 altitude

================================================================================
MSG: gnss_info_msgs/SatelliteSkyPosition
# SPDX-License-Identifier: BSD-3-Clause
# SPDX-FileCopyrightText: Czech Technical University in Prague

# Position of a satellite in the sky as seen from a particular reference position.

uint32 satcat_id  # SATCAT number (NORAD ID) of the satellite.
float32 azimuth_deg  # Azimuth in the sky (in degress, NED convention).
float32 elevation_deg  # Elevation in the sky (in degress, positive values above local horizon).
float64 distance  # Distance of the satellite to the reference position (corrected for Sagnac effect; in meters).
================================================================================
MSG: gnss_info_msgs/DOP
# SPDX-License-Identifier: BSD-3-Clause
# SPDX-FileCopyrightText: Czech Technical University in Prague

# Dilution of precision. If less than 4 satellites are visible, all DOP values should be set to infinity.

float32 gdop  # Geometrical dilution of precision
float32 pdop  # Position dilution of precision
float32 hdop  # Horizontal dilution of precision
float32 vdop  # Vertical dilution of precision
float32 tdop  # Time dilution of precision"""
  __slots__ = ['header','reference_position','elevation_mask_deg','satellites','dop']
  _slot_types = ['std_msgs/Header','geographic_msgs/GeoPoint','float32','gnss_info_msgs/SatelliteSkyPosition[]','gnss_info_msgs/DOP']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,reference_position,elevation_mask_deg,satellites,dop

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(SkyView, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.reference_position is None:
        self.reference_position = geographic_msgs.msg.GeoPoint()
      if self.elevation_mask_deg is None:
        self.elevation_mask_deg = 0.
      if self.satellites is None:
        self.satellites = []
      if self.dop is None:
        self.dop = gnss_info_msgs.msg.DOP()
    else:
      self.header = std_msgs.msg.Header()
      self.reference_position = geographic_msgs.msg.GeoPoint()
      self.elevation_mask_deg = 0.
      self.satellites = []
      self.dop = gnss_info_msgs.msg.DOP()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_3df().pack(_x.reference_position.latitude, _x.reference_position.longitude, _x.reference_position.altitude, _x.elevation_mask_deg))
      length = len(self.satellites)
      buff.write(_struct_I.pack(length))
      for val1 in self.satellites:
        _x = val1
        buff.write(_get_struct_I2fd().pack(_x.satcat_id, _x.azimuth_deg, _x.elevation_deg, _x.distance))
      _x = self
      buff.write(_get_struct_5f().pack(_x.dop.gdop, _x.dop.pdop, _x.dop.hdop, _x.dop.vdop, _x.dop.tdop))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.reference_position is None:
        self.reference_position = geographic_msgs.msg.GeoPoint()
      if self.satellites is None:
        self.satellites = None
      if self.dop is None:
        self.dop = gnss_info_msgs.msg.DOP()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 28
      (_x.reference_position.latitude, _x.reference_position.longitude, _x.reference_position.altitude, _x.elevation_mask_deg,) = _get_struct_3df().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.satellites = []
      for i in range(0, length):
        val1 = gnss_info_msgs.msg.SatelliteSkyPosition()
        _x = val1
        start = end
        end += 20
        (_x.satcat_id, _x.azimuth_deg, _x.elevation_deg, _x.distance,) = _get_struct_I2fd().unpack(str[start:end])
        self.satellites.append(val1)
      _x = self
      start = end
      end += 20
      (_x.dop.gdop, _x.dop.pdop, _x.dop.hdop, _x.dop.vdop, _x.dop.tdop,) = _get_struct_5f().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_3df().pack(_x.reference_position.latitude, _x.reference_position.longitude, _x.reference_position.altitude, _x.elevation_mask_deg))
      length = len(self.satellites)
      buff.write(_struct_I.pack(length))
      for val1 in self.satellites:
        _x = val1
        buff.write(_get_struct_I2fd().pack(_x.satcat_id, _x.azimuth_deg, _x.elevation_deg, _x.distance))
      _x = self
      buff.write(_get_struct_5f().pack(_x.dop.gdop, _x.dop.pdop, _x.dop.hdop, _x.dop.vdop, _x.dop.tdop))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.reference_position is None:
        self.reference_position = geographic_msgs.msg.GeoPoint()
      if self.satellites is None:
        self.satellites = None
      if self.dop is None:
        self.dop = gnss_info_msgs.msg.DOP()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 28
      (_x.reference_position.latitude, _x.reference_position.longitude, _x.reference_position.altitude, _x.elevation_mask_deg,) = _get_struct_3df().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.satellites = []
      for i in range(0, length):
        val1 = gnss_info_msgs.msg.SatelliteSkyPosition()
        _x = val1
        start = end
        end += 20
        (_x.satcat_id, _x.azimuth_deg, _x.elevation_deg, _x.distance,) = _get_struct_I2fd().unpack(str[start:end])
        self.satellites.append(val1)
      _x = self
      start = end
      end += 20
      (_x.dop.gdop, _x.dop.pdop, _x.dop.hdop, _x.dop.vdop, _x.dop.tdop,) = _get_struct_5f().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
_struct_3df = None
def _get_struct_3df():
    global _struct_3df
    if _struct_3df is None:
        _struct_3df = struct.Struct("<3df")
    return _struct_3df
_struct_5f = None
def _get_struct_5f():
    global _struct_5f
    if _struct_5f is None:
        _struct_5f = struct.Struct("<5f")
    return _struct_5f
_struct_I2fd = None
def _get_struct_I2fd():
    global _struct_I2fd
    if _struct_I2fd is None:
        _struct_I2fd = struct.Struct("<I2fd")
    return _struct_I2fd
