// Auto-generated. Do not edit!

// (in-package gnss_info_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let SatelliteSignal = require('./SatelliteSignal.js');

//-----------------------------------------------------------

class SatelliteInfo {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.stamp = null;
      this.satcat_id = null;
      this.name = null;
      this.prn = null;
      this.constellation = null;
      this.active = null;
      this.signals = null;
    }
    else {
      if (initObj.hasOwnProperty('stamp')) {
        this.stamp = initObj.stamp
      }
      else {
        this.stamp = {secs: 0, nsecs: 0};
      }
      if (initObj.hasOwnProperty('satcat_id')) {
        this.satcat_id = initObj.satcat_id
      }
      else {
        this.satcat_id = 0;
      }
      if (initObj.hasOwnProperty('name')) {
        this.name = initObj.name
      }
      else {
        this.name = '';
      }
      if (initObj.hasOwnProperty('prn')) {
        this.prn = initObj.prn
      }
      else {
        this.prn = '';
      }
      if (initObj.hasOwnProperty('constellation')) {
        this.constellation = initObj.constellation
      }
      else {
        this.constellation = '';
      }
      if (initObj.hasOwnProperty('active')) {
        this.active = initObj.active
      }
      else {
        this.active = false;
      }
      if (initObj.hasOwnProperty('signals')) {
        this.signals = initObj.signals
      }
      else {
        this.signals = [];
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type SatelliteInfo
    // Serialize message field [stamp]
    bufferOffset = _serializer.time(obj.stamp, buffer, bufferOffset);
    // Serialize message field [satcat_id]
    bufferOffset = _serializer.uint32(obj.satcat_id, buffer, bufferOffset);
    // Serialize message field [name]
    bufferOffset = _serializer.string(obj.name, buffer, bufferOffset);
    // Serialize message field [prn]
    bufferOffset = _serializer.string(obj.prn, buffer, bufferOffset);
    // Serialize message field [constellation]
    bufferOffset = _serializer.string(obj.constellation, buffer, bufferOffset);
    // Serialize message field [active]
    bufferOffset = _serializer.bool(obj.active, buffer, bufferOffset);
    // Serialize message field [signals]
    // Serialize the length for message field [signals]
    bufferOffset = _serializer.uint32(obj.signals.length, buffer, bufferOffset);
    obj.signals.forEach((val) => {
      bufferOffset = SatelliteSignal.serialize(val, buffer, bufferOffset);
    });
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type SatelliteInfo
    let len;
    let data = new SatelliteInfo(null);
    // Deserialize message field [stamp]
    data.stamp = _deserializer.time(buffer, bufferOffset);
    // Deserialize message field [satcat_id]
    data.satcat_id = _deserializer.uint32(buffer, bufferOffset);
    // Deserialize message field [name]
    data.name = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [prn]
    data.prn = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [constellation]
    data.constellation = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [active]
    data.active = _deserializer.bool(buffer, bufferOffset);
    // Deserialize message field [signals]
    // Deserialize array length for message field [signals]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.signals = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.signals[i] = SatelliteSignal.deserialize(buffer, bufferOffset)
    }
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += _getByteLength(object.name);
    length += _getByteLength(object.prn);
    length += _getByteLength(object.constellation);
    object.signals.forEach((val) => {
      length += SatelliteSignal.getMessageSize(val);
    });
    return length + 29;
  }

  static datatype() {
    // Returns string type for a message object
    return 'gnss_info_msgs/SatelliteInfo';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'a61b81a944b8abaf2d465044f1d82ef3';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # SPDX-License-Identifier: BSD-3-Clause
    # SPDX-FileCopyrightText: Czech Technical University in Prague
    
    # General information about a satellite.
    
    time stamp  # The time to which this data are valid. Some values like prn or active state may change over time.
    uint32 satcat_id  # SATCAT number (NORAD ID) of the satellite. This ID should be used as a stable identifier.
    string name  # Name of the satellite. It should not be used as a stable identifier.
    string prn  # PRN of the satellite at the given time. If the satellite is not active at the given time, empty string.
                # Either 2-3 digits, or 1 letter and 2 digits.
    string constellation  # One of CONSTELLATION_* values from Enums.msg
    bool active  # True if the satellite is in operational state, False otherwise (decommissioned, faulty, experimental).
    SatelliteSignal[] signals  # The signal types transmitted by the satellite at the given time.
    ================================================================================
    MSG: gnss_info_msgs/SatelliteSignal
    # SPDX-License-Identifier: BSD-3-Clause
    # SPDX-FileCopyrightText: Czech Technical University in Prague
    
    # General information about a particular satellite signal.
    
    string name  # Name of the signal. One of SIGNAL_* values from Enums.msg
    string constellation  # Constellation the signal is a part of. One of CONSTELLATION_* values from Enums.msg
    float32 frequency  # Center frequency band of the signal in Hz (0 if not known). For GLONASS, the channel-based
                       # frequency shift should be applied.
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new SatelliteInfo(null);
    if (msg.stamp !== undefined) {
      resolved.stamp = msg.stamp;
    }
    else {
      resolved.stamp = {secs: 0, nsecs: 0}
    }

    if (msg.satcat_id !== undefined) {
      resolved.satcat_id = msg.satcat_id;
    }
    else {
      resolved.satcat_id = 0
    }

    if (msg.name !== undefined) {
      resolved.name = msg.name;
    }
    else {
      resolved.name = ''
    }

    if (msg.prn !== undefined) {
      resolved.prn = msg.prn;
    }
    else {
      resolved.prn = ''
    }

    if (msg.constellation !== undefined) {
      resolved.constellation = msg.constellation;
    }
    else {
      resolved.constellation = ''
    }

    if (msg.active !== undefined) {
      resolved.active = msg.active;
    }
    else {
      resolved.active = false
    }

    if (msg.signals !== undefined) {
      resolved.signals = new Array(msg.signals.length);
      for (let i = 0; i < resolved.signals.length; ++i) {
        resolved.signals[i] = SatelliteSignal.Resolve(msg.signals[i]);
      }
    }
    else {
      resolved.signals = []
    }

    return resolved;
    }
};

module.exports = SatelliteInfo;
