// Auto-generated. Do not edit!

// (in-package gnss_info_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let SatellitePosition = require('./SatellitePosition.js');
let SignalObservation = require('./SignalObservation.js');

//-----------------------------------------------------------

class SatelliteObservation {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.position = null;
      this.signals = null;
    }
    else {
      if (initObj.hasOwnProperty('position')) {
        this.position = initObj.position
      }
      else {
        this.position = new SatellitePosition();
      }
      if (initObj.hasOwnProperty('signals')) {
        this.signals = initObj.signals
      }
      else {
        this.signals = [];
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type SatelliteObservation
    // Serialize message field [position]
    bufferOffset = SatellitePosition.serialize(obj.position, buffer, bufferOffset);
    // Serialize message field [signals]
    // Serialize the length for message field [signals]
    bufferOffset = _serializer.uint32(obj.signals.length, buffer, bufferOffset);
    obj.signals.forEach((val) => {
      bufferOffset = SignalObservation.serialize(val, buffer, bufferOffset);
    });
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type SatelliteObservation
    let len;
    let data = new SatelliteObservation(null);
    // Deserialize message field [position]
    data.position = SatellitePosition.deserialize(buffer, bufferOffset);
    // Deserialize message field [signals]
    // Deserialize array length for message field [signals]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.signals = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.signals[i] = SignalObservation.deserialize(buffer, bufferOffset)
    }
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    object.signals.forEach((val) => {
      length += SignalObservation.getMessageSize(val);
    });
    return length + 200;
  }

  static datatype() {
    // Returns string type for a message object
    return 'gnss_info_msgs/SatelliteObservation';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'e5166f13ee4cd50ed431ed5a5b2ed396';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # SPDX-License-Identifier: BSD-3-Clause
    # SPDX-FileCopyrightText: Czech Technical University in Prague
    
    # Observation of a single satellite in the sky by a particular sensor. This message is intended to be used only inside
    # SatellitesObservation message.
    
    SatellitePosition position
    SignalObservation[] signals
    ================================================================================
    MSG: gnss_info_msgs/SatellitePosition
    # SPDX-License-Identifier: BSD-3-Clause
    # SPDX-FileCopyrightText: Czech Technical University in Prague
    
    # ECEF position and velocity of a satellite.
    
    uint32 satcat_id  # SATCAT number (NORAD ID) of the satellite.
    geometry_msgs/Point position  # Position of the satellite in ECEF frame.
    geometry_msgs/Vector3 velocity  # Velocity of the satellite in ECEF frame.
    float64[9] position_covariance  # Row-major covariance matrix of position. If all zeros, it is not specified.
    float64[9] velocity_covariance  # Row-major covariance matrix of velocity. If all zeros, it is not specified.
    ================================================================================
    MSG: geometry_msgs/Point
    # This contains the position of a point in free space
    float64 x
    float64 y
    float64 z
    
    ================================================================================
    MSG: geometry_msgs/Vector3
    # This represents a vector in free space. 
    # It is only meant to represent a direction. Therefore, it does not
    # make sense to apply a translation to it (e.g., when applying a 
    # generic rigid transformation to a Vector3, tf2 will only apply the
    # rotation). If you want your data to be translatable too, use the
    # geometry_msgs/Point message instead.
    
    float64 x
    float64 y
    float64 z
    ================================================================================
    MSG: gnss_info_msgs/SignalObservation
    # SPDX-License-Identifier: BSD-3-Clause
    # SPDX-FileCopyrightText: Czech Technical University in Prague
    
    # Observation of a single satellite in the sky by a particular sensor. This message is intended to be used only inside
    # SatellitesObservation message.
    
    SatelliteSignal signal
    float64 pseudorange  # The measured pseudorange (NaN if not measured; in meters).
    float64 carrier_phase  # The estimated carrier phase (NaN if not measured; float number of cycles).
    float64 doppler_shift  # Difference between observed and emitted frequency of the carrier (NaN if not measured; in Hz).
    float64 carrier_to_noise_ratio  #  Strength of the received signal (NaN if not measured; in dbHz).
    bool carrier_locked  # False if carrier lock has been lost since the last measurement (thus a cycle slip is possible).
    ================================================================================
    MSG: gnss_info_msgs/SatelliteSignal
    # SPDX-License-Identifier: BSD-3-Clause
    # SPDX-FileCopyrightText: Czech Technical University in Prague
    
    # General information about a particular satellite signal.
    
    string name  # Name of the signal. One of SIGNAL_* values from Enums.msg
    string constellation  # Constellation the signal is a part of. One of CONSTELLATION_* values from Enums.msg
    float32 frequency  # Center frequency band of the signal in Hz (0 if not known). For GLONASS, the channel-based
                       # frequency shift should be applied.
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new SatelliteObservation(null);
    if (msg.position !== undefined) {
      resolved.position = SatellitePosition.Resolve(msg.position)
    }
    else {
      resolved.position = new SatellitePosition()
    }

    if (msg.signals !== undefined) {
      resolved.signals = new Array(msg.signals.length);
      for (let i = 0; i < resolved.signals.length; ++i) {
        resolved.signals[i] = SignalObservation.Resolve(msg.signals[i]);
      }
    }
    else {
      resolved.signals = []
    }

    return resolved;
    }
};

module.exports = SatelliteObservation;
