// Auto-generated. Do not edit!

// (in-package gnss_info_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;

//-----------------------------------------------------------

class SatelliteSkyPosition {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.satcat_id = null;
      this.azimuth_deg = null;
      this.elevation_deg = null;
      this.distance = null;
    }
    else {
      if (initObj.hasOwnProperty('satcat_id')) {
        this.satcat_id = initObj.satcat_id
      }
      else {
        this.satcat_id = 0;
      }
      if (initObj.hasOwnProperty('azimuth_deg')) {
        this.azimuth_deg = initObj.azimuth_deg
      }
      else {
        this.azimuth_deg = 0.0;
      }
      if (initObj.hasOwnProperty('elevation_deg')) {
        this.elevation_deg = initObj.elevation_deg
      }
      else {
        this.elevation_deg = 0.0;
      }
      if (initObj.hasOwnProperty('distance')) {
        this.distance = initObj.distance
      }
      else {
        this.distance = 0.0;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type SatelliteSkyPosition
    // Serialize message field [satcat_id]
    bufferOffset = _serializer.uint32(obj.satcat_id, buffer, bufferOffset);
    // Serialize message field [azimuth_deg]
    bufferOffset = _serializer.float32(obj.azimuth_deg, buffer, bufferOffset);
    // Serialize message field [elevation_deg]
    bufferOffset = _serializer.float32(obj.elevation_deg, buffer, bufferOffset);
    // Serialize message field [distance]
    bufferOffset = _serializer.float64(obj.distance, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type SatelliteSkyPosition
    let len;
    let data = new SatelliteSkyPosition(null);
    // Deserialize message field [satcat_id]
    data.satcat_id = _deserializer.uint32(buffer, bufferOffset);
    // Deserialize message field [azimuth_deg]
    data.azimuth_deg = _deserializer.float32(buffer, bufferOffset);
    // Deserialize message field [elevation_deg]
    data.elevation_deg = _deserializer.float32(buffer, bufferOffset);
    // Deserialize message field [distance]
    data.distance = _deserializer.float64(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    return 20;
  }

  static datatype() {
    // Returns string type for a message object
    return 'gnss_info_msgs/SatelliteSkyPosition';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'a5a93b6ae2c1ee19d32ebb4c3563c1c8';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # SPDX-License-Identifier: BSD-3-Clause
    # SPDX-FileCopyrightText: Czech Technical University in Prague
    
    # Position of a satellite in the sky as seen from a particular reference position.
    
    uint32 satcat_id  # SATCAT number (NORAD ID) of the satellite.
    float32 azimuth_deg  # Azimuth in the sky (in degress, NED convention).
    float32 elevation_deg  # Elevation in the sky (in degress, positive values above local horizon).
    float64 distance  # Distance of the satellite to the reference position (corrected for Sagnac effect; in meters).
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new SatelliteSkyPosition(null);
    if (msg.satcat_id !== undefined) {
      resolved.satcat_id = msg.satcat_id;
    }
    else {
      resolved.satcat_id = 0
    }

    if (msg.azimuth_deg !== undefined) {
      resolved.azimuth_deg = msg.azimuth_deg;
    }
    else {
      resolved.azimuth_deg = 0.0
    }

    if (msg.elevation_deg !== undefined) {
      resolved.elevation_deg = msg.elevation_deg;
    }
    else {
      resolved.elevation_deg = 0.0
    }

    if (msg.distance !== undefined) {
      resolved.distance = msg.distance;
    }
    else {
      resolved.distance = 0.0
    }

    return resolved;
    }
};

module.exports = SatelliteSkyPosition;
