// Auto-generated. Do not edit!

// (in-package gnss_info_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let SatelliteInfo = require('./SatelliteInfo.js');

//-----------------------------------------------------------

class SatellitesList {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.satellites = null;
    }
    else {
      if (initObj.hasOwnProperty('satellites')) {
        this.satellites = initObj.satellites
      }
      else {
        this.satellites = [];
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type SatellitesList
    // Serialize message field [satellites]
    // Serialize the length for message field [satellites]
    bufferOffset = _serializer.uint32(obj.satellites.length, buffer, bufferOffset);
    obj.satellites.forEach((val) => {
      bufferOffset = SatelliteInfo.serialize(val, buffer, bufferOffset);
    });
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type SatellitesList
    let len;
    let data = new SatellitesList(null);
    // Deserialize message field [satellites]
    // Deserialize array length for message field [satellites]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.satellites = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.satellites[i] = SatelliteInfo.deserialize(buffer, bufferOffset)
    }
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    object.satellites.forEach((val) => {
      length += SatelliteInfo.getMessageSize(val);
    });
    return length + 4;
  }

  static datatype() {
    // Returns string type for a message object
    return 'gnss_info_msgs/SatellitesList';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '839c1013b162d3068ee7b42fda814e1f';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # SPDX-License-Identifier: BSD-3-Clause
    # SPDX-FileCopyrightText: Czech Technical University in Prague
    
    # General information about several satellites.
    
    SatelliteInfo[] satellites  # The satellites.
    ================================================================================
    MSG: gnss_info_msgs/SatelliteInfo
    # SPDX-License-Identifier: BSD-3-Clause
    # SPDX-FileCopyrightText: Czech Technical University in Prague
    
    # General information about a satellite.
    
    time stamp  # The time to which this data are valid. Some values like prn or active state may change over time.
    uint32 satcat_id  # SATCAT number (NORAD ID) of the satellite. This ID should be used as a stable identifier.
    string name  # Name of the satellite. It should not be used as a stable identifier.
    string prn  # PRN of the satellite at the given time. If the satellite is not active at the given time, empty string.
                # Either 2-3 digits, or 1 letter and 2 digits.
    string constellation  # One of CONSTELLATION_* values from Enums.msg
    bool active  # True if the satellite is in operational state, False otherwise (decommissioned, faulty, experimental).
    SatelliteSignal[] signals  # The signal types transmitted by the satellite at the given time.
    ================================================================================
    MSG: gnss_info_msgs/SatelliteSignal
    # SPDX-License-Identifier: BSD-3-Clause
    # SPDX-FileCopyrightText: Czech Technical University in Prague
    
    # General information about a particular satellite signal.
    
    string name  # Name of the signal. One of SIGNAL_* values from Enums.msg
    string constellation  # Constellation the signal is a part of. One of CONSTELLATION_* values from Enums.msg
    float32 frequency  # Center frequency band of the signal in Hz (0 if not known). For GLONASS, the channel-based
                       # frequency shift should be applied.
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new SatellitesList(null);
    if (msg.satellites !== undefined) {
      resolved.satellites = new Array(msg.satellites.length);
      for (let i = 0; i < resolved.satellites.length; ++i) {
        resolved.satellites[i] = SatelliteInfo.Resolve(msg.satellites[i]);
      }
    }
    else {
      resolved.satellites = []
    }

    return resolved;
    }
};

module.exports = SatellitesList;
