// Auto-generated. Do not edit!

// (in-package gnss_info_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let SatelliteObservation = require('./SatelliteObservation.js');
let std_msgs = _finder('std_msgs');

//-----------------------------------------------------------

class SatellitesObservations {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.header = null;
      this.elevation_mask_deg = null;
      this.observations = null;
    }
    else {
      if (initObj.hasOwnProperty('header')) {
        this.header = initObj.header
      }
      else {
        this.header = new std_msgs.msg.Header();
      }
      if (initObj.hasOwnProperty('elevation_mask_deg')) {
        this.elevation_mask_deg = initObj.elevation_mask_deg
      }
      else {
        this.elevation_mask_deg = 0.0;
      }
      if (initObj.hasOwnProperty('observations')) {
        this.observations = initObj.observations
      }
      else {
        this.observations = [];
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type SatellitesObservations
    // Serialize message field [header]
    bufferOffset = std_msgs.msg.Header.serialize(obj.header, buffer, bufferOffset);
    // Serialize message field [elevation_mask_deg]
    bufferOffset = _serializer.float32(obj.elevation_mask_deg, buffer, bufferOffset);
    // Serialize message field [observations]
    // Serialize the length for message field [observations]
    bufferOffset = _serializer.uint32(obj.observations.length, buffer, bufferOffset);
    obj.observations.forEach((val) => {
      bufferOffset = SatelliteObservation.serialize(val, buffer, bufferOffset);
    });
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type SatellitesObservations
    let len;
    let data = new SatellitesObservations(null);
    // Deserialize message field [header]
    data.header = std_msgs.msg.Header.deserialize(buffer, bufferOffset);
    // Deserialize message field [elevation_mask_deg]
    data.elevation_mask_deg = _deserializer.float32(buffer, bufferOffset);
    // Deserialize message field [observations]
    // Deserialize array length for message field [observations]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.observations = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.observations[i] = SatelliteObservation.deserialize(buffer, bufferOffset)
    }
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += std_msgs.msg.Header.getMessageSize(object.header);
    object.observations.forEach((val) => {
      length += SatelliteObservation.getMessageSize(val);
    });
    return length + 8;
  }

  static datatype() {
    // Returns string type for a message object
    return 'gnss_info_msgs/SatellitesObservations';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'e295439f84d7f1f02052eff4806eeba9';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # SPDX-License-Identifier: BSD-3-Clause
    # SPDX-FileCopyrightText: Czech Technical University in Prague
    
    # Observation of satellites in the sky by a particular sensor.
    
    Header header  # Frame should be "wgs84" or any other datum in which the reference position is expressed.
                   # Stamp is receiver time.
    float32 elevation_mask_deg  # Minimum elevation of satellites that are considered (in degrees).
    SatelliteObservation[] observations
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    string frame_id
    
    ================================================================================
    MSG: gnss_info_msgs/SatelliteObservation
    # SPDX-License-Identifier: BSD-3-Clause
    # SPDX-FileCopyrightText: Czech Technical University in Prague
    
    # Observation of a single satellite in the sky by a particular sensor. This message is intended to be used only inside
    # SatellitesObservation message.
    
    SatellitePosition position
    SignalObservation[] signals
    ================================================================================
    MSG: gnss_info_msgs/SatellitePosition
    # SPDX-License-Identifier: BSD-3-Clause
    # SPDX-FileCopyrightText: Czech Technical University in Prague
    
    # ECEF position and velocity of a satellite.
    
    uint32 satcat_id  # SATCAT number (NORAD ID) of the satellite.
    geometry_msgs/Point position  # Position of the satellite in ECEF frame.
    geometry_msgs/Vector3 velocity  # Velocity of the satellite in ECEF frame.
    float64[9] position_covariance  # Row-major covariance matrix of position. If all zeros, it is not specified.
    float64[9] velocity_covariance  # Row-major covariance matrix of velocity. If all zeros, it is not specified.
    ================================================================================
    MSG: geometry_msgs/Point
    # This contains the position of a point in free space
    float64 x
    float64 y
    float64 z
    
    ================================================================================
    MSG: geometry_msgs/Vector3
    # This represents a vector in free space. 
    # It is only meant to represent a direction. Therefore, it does not
    # make sense to apply a translation to it (e.g., when applying a 
    # generic rigid transformation to a Vector3, tf2 will only apply the
    # rotation). If you want your data to be translatable too, use the
    # geometry_msgs/Point message instead.
    
    float64 x
    float64 y
    float64 z
    ================================================================================
    MSG: gnss_info_msgs/SignalObservation
    # SPDX-License-Identifier: BSD-3-Clause
    # SPDX-FileCopyrightText: Czech Technical University in Prague
    
    # Observation of a single satellite in the sky by a particular sensor. This message is intended to be used only inside
    # SatellitesObservation message.
    
    SatelliteSignal signal
    float64 pseudorange  # The measured pseudorange (NaN if not measured; in meters).
    float64 carrier_phase  # The estimated carrier phase (NaN if not measured; float number of cycles).
    float64 doppler_shift  # Difference between observed and emitted frequency of the carrier (NaN if not measured; in Hz).
    float64 carrier_to_noise_ratio  #  Strength of the received signal (NaN if not measured; in dbHz).
    bool carrier_locked  # False if carrier lock has been lost since the last measurement (thus a cycle slip is possible).
    ================================================================================
    MSG: gnss_info_msgs/SatelliteSignal
    # SPDX-License-Identifier: BSD-3-Clause
    # SPDX-FileCopyrightText: Czech Technical University in Prague
    
    # General information about a particular satellite signal.
    
    string name  # Name of the signal. One of SIGNAL_* values from Enums.msg
    string constellation  # Constellation the signal is a part of. One of CONSTELLATION_* values from Enums.msg
    float32 frequency  # Center frequency band of the signal in Hz (0 if not known). For GLONASS, the channel-based
                       # frequency shift should be applied.
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new SatellitesObservations(null);
    if (msg.header !== undefined) {
      resolved.header = std_msgs.msg.Header.Resolve(msg.header)
    }
    else {
      resolved.header = new std_msgs.msg.Header()
    }

    if (msg.elevation_mask_deg !== undefined) {
      resolved.elevation_mask_deg = msg.elevation_mask_deg;
    }
    else {
      resolved.elevation_mask_deg = 0.0
    }

    if (msg.observations !== undefined) {
      resolved.observations = new Array(msg.observations.length);
      for (let i = 0; i < resolved.observations.length; ++i) {
        resolved.observations[i] = SatelliteObservation.Resolve(msg.observations[i]);
      }
    }
    else {
      resolved.observations = []
    }

    return resolved;
    }
};

module.exports = SatellitesObservations;
