// Auto-generated. Do not edit!

// (in-package gnss_info_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let SatellitePosition = require('./SatellitePosition.js');
let std_msgs = _finder('std_msgs');

//-----------------------------------------------------------

class SatellitesPositions {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.header = null;
      this.satellites = null;
    }
    else {
      if (initObj.hasOwnProperty('header')) {
        this.header = initObj.header
      }
      else {
        this.header = new std_msgs.msg.Header();
      }
      if (initObj.hasOwnProperty('satellites')) {
        this.satellites = initObj.satellites
      }
      else {
        this.satellites = [];
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type SatellitesPositions
    // Serialize message field [header]
    bufferOffset = std_msgs.msg.Header.serialize(obj.header, buffer, bufferOffset);
    // Serialize message field [satellites]
    // Serialize the length for message field [satellites]
    bufferOffset = _serializer.uint32(obj.satellites.length, buffer, bufferOffset);
    obj.satellites.forEach((val) => {
      bufferOffset = SatellitePosition.serialize(val, buffer, bufferOffset);
    });
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type SatellitesPositions
    let len;
    let data = new SatellitesPositions(null);
    // Deserialize message field [header]
    data.header = std_msgs.msg.Header.deserialize(buffer, bufferOffset);
    // Deserialize message field [satellites]
    // Deserialize array length for message field [satellites]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.satellites = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.satellites[i] = SatellitePosition.deserialize(buffer, bufferOffset)
    }
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += std_msgs.msg.Header.getMessageSize(object.header);
    length += 196 * object.satellites.length;
    return length + 4;
  }

  static datatype() {
    // Returns string type for a message object
    return 'gnss_info_msgs/SatellitesPositions';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '7cb598d04d9db05f993d1dae99ac72d6';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # SPDX-License-Identifier: BSD-3-Clause
    # SPDX-FileCopyrightText: Czech Technical University in Prague
    
    # Positions of satellites at a particular time. It can be either all available satellites, or only satellites visible by
    # a particular sensor.
    
    Header header  # Frame should be "ecef" or any other Cartesian frame.
    SatellitePosition[] satellites
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    string frame_id
    
    ================================================================================
    MSG: gnss_info_msgs/SatellitePosition
    # SPDX-License-Identifier: BSD-3-Clause
    # SPDX-FileCopyrightText: Czech Technical University in Prague
    
    # ECEF position and velocity of a satellite.
    
    uint32 satcat_id  # SATCAT number (NORAD ID) of the satellite.
    geometry_msgs/Point position  # Position of the satellite in ECEF frame.
    geometry_msgs/Vector3 velocity  # Velocity of the satellite in ECEF frame.
    float64[9] position_covariance  # Row-major covariance matrix of position. If all zeros, it is not specified.
    float64[9] velocity_covariance  # Row-major covariance matrix of velocity. If all zeros, it is not specified.
    ================================================================================
    MSG: geometry_msgs/Point
    # This contains the position of a point in free space
    float64 x
    float64 y
    float64 z
    
    ================================================================================
    MSG: geometry_msgs/Vector3
    # This represents a vector in free space. 
    # It is only meant to represent a direction. Therefore, it does not
    # make sense to apply a translation to it (e.g., when applying a 
    # generic rigid transformation to a Vector3, tf2 will only apply the
    # rotation). If you want your data to be translatable too, use the
    # geometry_msgs/Point message instead.
    
    float64 x
    float64 y
    float64 z
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new SatellitesPositions(null);
    if (msg.header !== undefined) {
      resolved.header = std_msgs.msg.Header.Resolve(msg.header)
    }
    else {
      resolved.header = new std_msgs.msg.Header()
    }

    if (msg.satellites !== undefined) {
      resolved.satellites = new Array(msg.satellites.length);
      for (let i = 0; i < resolved.satellites.length; ++i) {
        resolved.satellites[i] = SatellitePosition.Resolve(msg.satellites[i]);
      }
    }
    else {
      resolved.satellites = []
    }

    return resolved;
    }
};

module.exports = SatellitesPositions;
