// Auto-generated. Do not edit!

// (in-package gnss_info_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let SatelliteSignal = require('./SatelliteSignal.js');

//-----------------------------------------------------------

class SignalObservation {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.signal = null;
      this.pseudorange = null;
      this.carrier_phase = null;
      this.doppler_shift = null;
      this.carrier_to_noise_ratio = null;
      this.carrier_locked = null;
    }
    else {
      if (initObj.hasOwnProperty('signal')) {
        this.signal = initObj.signal
      }
      else {
        this.signal = new SatelliteSignal();
      }
      if (initObj.hasOwnProperty('pseudorange')) {
        this.pseudorange = initObj.pseudorange
      }
      else {
        this.pseudorange = 0.0;
      }
      if (initObj.hasOwnProperty('carrier_phase')) {
        this.carrier_phase = initObj.carrier_phase
      }
      else {
        this.carrier_phase = 0.0;
      }
      if (initObj.hasOwnProperty('doppler_shift')) {
        this.doppler_shift = initObj.doppler_shift
      }
      else {
        this.doppler_shift = 0.0;
      }
      if (initObj.hasOwnProperty('carrier_to_noise_ratio')) {
        this.carrier_to_noise_ratio = initObj.carrier_to_noise_ratio
      }
      else {
        this.carrier_to_noise_ratio = 0.0;
      }
      if (initObj.hasOwnProperty('carrier_locked')) {
        this.carrier_locked = initObj.carrier_locked
      }
      else {
        this.carrier_locked = false;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type SignalObservation
    // Serialize message field [signal]
    bufferOffset = SatelliteSignal.serialize(obj.signal, buffer, bufferOffset);
    // Serialize message field [pseudorange]
    bufferOffset = _serializer.float64(obj.pseudorange, buffer, bufferOffset);
    // Serialize message field [carrier_phase]
    bufferOffset = _serializer.float64(obj.carrier_phase, buffer, bufferOffset);
    // Serialize message field [doppler_shift]
    bufferOffset = _serializer.float64(obj.doppler_shift, buffer, bufferOffset);
    // Serialize message field [carrier_to_noise_ratio]
    bufferOffset = _serializer.float64(obj.carrier_to_noise_ratio, buffer, bufferOffset);
    // Serialize message field [carrier_locked]
    bufferOffset = _serializer.bool(obj.carrier_locked, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type SignalObservation
    let len;
    let data = new SignalObservation(null);
    // Deserialize message field [signal]
    data.signal = SatelliteSignal.deserialize(buffer, bufferOffset);
    // Deserialize message field [pseudorange]
    data.pseudorange = _deserializer.float64(buffer, bufferOffset);
    // Deserialize message field [carrier_phase]
    data.carrier_phase = _deserializer.float64(buffer, bufferOffset);
    // Deserialize message field [doppler_shift]
    data.doppler_shift = _deserializer.float64(buffer, bufferOffset);
    // Deserialize message field [carrier_to_noise_ratio]
    data.carrier_to_noise_ratio = _deserializer.float64(buffer, bufferOffset);
    // Deserialize message field [carrier_locked]
    data.carrier_locked = _deserializer.bool(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += SatelliteSignal.getMessageSize(object.signal);
    return length + 33;
  }

  static datatype() {
    // Returns string type for a message object
    return 'gnss_info_msgs/SignalObservation';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '673e2ca27df1e4872336572196854331';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # SPDX-License-Identifier: BSD-3-Clause
    # SPDX-FileCopyrightText: Czech Technical University in Prague
    
    # Observation of a single satellite in the sky by a particular sensor. This message is intended to be used only inside
    # SatellitesObservation message.
    
    SatelliteSignal signal
    float64 pseudorange  # The measured pseudorange (NaN if not measured; in meters).
    float64 carrier_phase  # The estimated carrier phase (NaN if not measured; float number of cycles).
    float64 doppler_shift  # Difference between observed and emitted frequency of the carrier (NaN if not measured; in Hz).
    float64 carrier_to_noise_ratio  #  Strength of the received signal (NaN if not measured; in dbHz).
    bool carrier_locked  # False if carrier lock has been lost since the last measurement (thus a cycle slip is possible).
    ================================================================================
    MSG: gnss_info_msgs/SatelliteSignal
    # SPDX-License-Identifier: BSD-3-Clause
    # SPDX-FileCopyrightText: Czech Technical University in Prague
    
    # General information about a particular satellite signal.
    
    string name  # Name of the signal. One of SIGNAL_* values from Enums.msg
    string constellation  # Constellation the signal is a part of. One of CONSTELLATION_* values from Enums.msg
    float32 frequency  # Center frequency band of the signal in Hz (0 if not known). For GLONASS, the channel-based
                       # frequency shift should be applied.
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new SignalObservation(null);
    if (msg.signal !== undefined) {
      resolved.signal = SatelliteSignal.Resolve(msg.signal)
    }
    else {
      resolved.signal = new SatelliteSignal()
    }

    if (msg.pseudorange !== undefined) {
      resolved.pseudorange = msg.pseudorange;
    }
    else {
      resolved.pseudorange = 0.0
    }

    if (msg.carrier_phase !== undefined) {
      resolved.carrier_phase = msg.carrier_phase;
    }
    else {
      resolved.carrier_phase = 0.0
    }

    if (msg.doppler_shift !== undefined) {
      resolved.doppler_shift = msg.doppler_shift;
    }
    else {
      resolved.doppler_shift = 0.0
    }

    if (msg.carrier_to_noise_ratio !== undefined) {
      resolved.carrier_to_noise_ratio = msg.carrier_to_noise_ratio;
    }
    else {
      resolved.carrier_to_noise_ratio = 0.0
    }

    if (msg.carrier_locked !== undefined) {
      resolved.carrier_locked = msg.carrier_locked;
    }
    else {
      resolved.carrier_locked = false
    }

    return resolved;
    }
};

module.exports = SignalObservation;
