// Auto-generated. Do not edit!

// (in-package gnss_info_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let SatelliteSkyPosition = require('./SatelliteSkyPosition.js');
let DOP = require('./DOP.js');
let std_msgs = _finder('std_msgs');
let geographic_msgs = _finder('geographic_msgs');

//-----------------------------------------------------------

class SkyView {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.header = null;
      this.reference_position = null;
      this.elevation_mask_deg = null;
      this.satellites = null;
      this.dop = null;
    }
    else {
      if (initObj.hasOwnProperty('header')) {
        this.header = initObj.header
      }
      else {
        this.header = new std_msgs.msg.Header();
      }
      if (initObj.hasOwnProperty('reference_position')) {
        this.reference_position = initObj.reference_position
      }
      else {
        this.reference_position = new geographic_msgs.msg.GeoPoint();
      }
      if (initObj.hasOwnProperty('elevation_mask_deg')) {
        this.elevation_mask_deg = initObj.elevation_mask_deg
      }
      else {
        this.elevation_mask_deg = 0.0;
      }
      if (initObj.hasOwnProperty('satellites')) {
        this.satellites = initObj.satellites
      }
      else {
        this.satellites = [];
      }
      if (initObj.hasOwnProperty('dop')) {
        this.dop = initObj.dop
      }
      else {
        this.dop = new DOP();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type SkyView
    // Serialize message field [header]
    bufferOffset = std_msgs.msg.Header.serialize(obj.header, buffer, bufferOffset);
    // Serialize message field [reference_position]
    bufferOffset = geographic_msgs.msg.GeoPoint.serialize(obj.reference_position, buffer, bufferOffset);
    // Serialize message field [elevation_mask_deg]
    bufferOffset = _serializer.float32(obj.elevation_mask_deg, buffer, bufferOffset);
    // Serialize message field [satellites]
    // Serialize the length for message field [satellites]
    bufferOffset = _serializer.uint32(obj.satellites.length, buffer, bufferOffset);
    obj.satellites.forEach((val) => {
      bufferOffset = SatelliteSkyPosition.serialize(val, buffer, bufferOffset);
    });
    // Serialize message field [dop]
    bufferOffset = DOP.serialize(obj.dop, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type SkyView
    let len;
    let data = new SkyView(null);
    // Deserialize message field [header]
    data.header = std_msgs.msg.Header.deserialize(buffer, bufferOffset);
    // Deserialize message field [reference_position]
    data.reference_position = geographic_msgs.msg.GeoPoint.deserialize(buffer, bufferOffset);
    // Deserialize message field [elevation_mask_deg]
    data.elevation_mask_deg = _deserializer.float32(buffer, bufferOffset);
    // Deserialize message field [satellites]
    // Deserialize array length for message field [satellites]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.satellites = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.satellites[i] = SatelliteSkyPosition.deserialize(buffer, bufferOffset)
    }
    // Deserialize message field [dop]
    data.dop = DOP.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += std_msgs.msg.Header.getMessageSize(object.header);
    length += 20 * object.satellites.length;
    return length + 52;
  }

  static datatype() {
    // Returns string type for a message object
    return 'gnss_info_msgs/SkyView';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'db0126e8f4334f9bf177545ff9630a5b';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # SPDX-License-Identifier: BSD-3-Clause
    # SPDX-FileCopyrightText: Czech Technical University in Prague
    
    # View of the satellites in the sky from a particular location on Earth. It can be either all available satellites,
    # or only satellites visible by a particular sensor.
    
    Header header  # Frame should be "wgs84" or any other datum in which the reference position is expressed.
    geographic_msgs/GeoPoint reference_position  # The reference position from which the sky is observed.
    float32 elevation_mask_deg  # Minimum elevation of satellites that are considered (in degrees).
    SatelliteSkyPosition[] satellites
    DOP dop
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    string frame_id
    
    ================================================================================
    MSG: geographic_msgs/GeoPoint
    # Geographic point, using the WGS 84 reference ellipsoid.
    
    # Latitude [degrees]. Positive is north of equator; negative is south
    # (-90 <= latitude <= +90).
    float64 latitude
    
    # Longitude [degrees]. Positive is east of prime meridian; negative is
    # west (-180 <= longitude <= +180). At the poles, latitude is -90 or
    # +90, and longitude is irrelevant, but must be in range.
    float64 longitude
    
    # Altitude [m]. Positive is above the WGS 84 ellipsoid (NaN if unspecified).
    float64 altitude
    
    ================================================================================
    MSG: gnss_info_msgs/SatelliteSkyPosition
    # SPDX-License-Identifier: BSD-3-Clause
    # SPDX-FileCopyrightText: Czech Technical University in Prague
    
    # Position of a satellite in the sky as seen from a particular reference position.
    
    uint32 satcat_id  # SATCAT number (NORAD ID) of the satellite.
    float32 azimuth_deg  # Azimuth in the sky (in degress, NED convention).
    float32 elevation_deg  # Elevation in the sky (in degress, positive values above local horizon).
    float64 distance  # Distance of the satellite to the reference position (corrected for Sagnac effect; in meters).
    ================================================================================
    MSG: gnss_info_msgs/DOP
    # SPDX-License-Identifier: BSD-3-Clause
    # SPDX-FileCopyrightText: Czech Technical University in Prague
    
    # Dilution of precision. If less than 4 satellites are visible, all DOP values should be set to infinity.
    
    float32 gdop  # Geometrical dilution of precision
    float32 pdop  # Position dilution of precision
    float32 hdop  # Horizontal dilution of precision
    float32 vdop  # Vertical dilution of precision
    float32 tdop  # Time dilution of precision
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new SkyView(null);
    if (msg.header !== undefined) {
      resolved.header = std_msgs.msg.Header.Resolve(msg.header)
    }
    else {
      resolved.header = new std_msgs.msg.Header()
    }

    if (msg.reference_position !== undefined) {
      resolved.reference_position = geographic_msgs.msg.GeoPoint.Resolve(msg.reference_position)
    }
    else {
      resolved.reference_position = new geographic_msgs.msg.GeoPoint()
    }

    if (msg.elevation_mask_deg !== undefined) {
      resolved.elevation_mask_deg = msg.elevation_mask_deg;
    }
    else {
      resolved.elevation_mask_deg = 0.0
    }

    if (msg.satellites !== undefined) {
      resolved.satellites = new Array(msg.satellites.length);
      for (let i = 0; i < resolved.satellites.length; ++i) {
        resolved.satellites[i] = SatelliteSkyPosition.Resolve(msg.satellites[i]);
      }
    }
    else {
      resolved.satellites = []
    }

    if (msg.dop !== undefined) {
      resolved.dop = DOP.Resolve(msg.dop)
    }
    else {
      resolved.dop = new DOP()
    }

    return resolved;
    }
};

module.exports = SkyView;
